// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Registry.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * The IceGrid registry allows clients create sessions
 * directly with the registry.
 * 
 * @see Session
 * @see AdminSession
 * 
 **/
public abstract class _RegistryDisp extends Ice.ObjectImpl implements Registry
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceGrid::Registry"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Create an administrative session.
     * 
     * @see Session
     * @see Glacier2.PermissionsVerifier
     * 
     * @return A proxy for the newly created session.
     * 
     * @param userId The user id.
     * 
     * @param password The password for the given user id.
     * 
     * @throws PermissionDeniedException Raised if the password for
     * the given user id is not correct, or if the user is not allowed
     * access.
     * 
     **/
    public final AdminSessionPrx createAdminSession(String userId, String password)
        throws PermissionDeniedException
    {
        return createAdminSession(userId, password, null);
    }

    /**
     * Create an administrative session from a secure connection.
     * 
     * @see Session
     * @see Glacier2.SSLPermissionsVerifier
     * 
     * @return A proxy for the newly created session.
     * 
     * @throws PermissionDeniedException Raised if the password for
     * the given user id is not correct, or if the user is not allowed
     * access.
     * 
     **/
    public final AdminSessionPrx createAdminSessionFromSecureConnection()
        throws PermissionDeniedException
    {
        return createAdminSessionFromSecureConnection(null);
    }

    /**
     * Create a client session.
     * 
     * @see Session
     * @see Glacier2.PermissionsVerifier
     * 
     * @return A proxy for the newly created session.
     * 
     * @param userId The user id.
     * 
     * @param password The password for the given user id.
     * 
     * @throws PermissionDeniedException Raised if the password for
     * the given user id is not correct, or if the user is not allowed
     * access.
     * 
     **/
    public final SessionPrx createSession(String userId, String password)
        throws PermissionDeniedException
    {
        return createSession(userId, password, null);
    }

    /**
     * Create a client session from a secure connection.
     * 
     * @see Session
     * @see Glacier2.SSLPermissionsVerifier
     * 
     * @return A proxy for the newly created session.
     * 
     * @throws PermissionDeniedException Raised if the password for
     * the given user id is not correct, or if the user is not allowed
     * access.
     * 
     **/
    public final SessionPrx createSessionFromSecureConnection()
        throws PermissionDeniedException
    {
        return createSessionFromSecureConnection(null);
    }

    /**
     * Get the session timeout. If a client or administrative client
     * doesn't call the session keepAlive method in the time interval
     * defined by this timeout, IceGrid might reap the session.
     * 
     * @see Session#keepAlive
     * @see AdminSession#keepAlive
     * 
     * @return The timeout (in seconds).
     * 
     **/
    public final int getSessionTimeout()
    {
        return getSessionTimeout(null);
    }

    public static Ice.DispatchStatus ___createSession(Registry __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String userId;
        String password;
        userId = __is.readString();
        password = __is.readString();
        __inS.endReadParams();
        try
        {
            SessionPrx __ret = __obj.createSession(userId, password, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            SessionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(PermissionDeniedException ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createAdminSession(Registry __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String userId;
        String password;
        userId = __is.readString();
        password = __is.readString();
        __inS.endReadParams();
        try
        {
            AdminSessionPrx __ret = __obj.createAdminSession(userId, password, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            AdminSessionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(PermissionDeniedException ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createSessionFromSecureConnection(Registry __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            SessionPrx __ret = __obj.createSessionFromSecureConnection(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            SessionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(PermissionDeniedException ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createAdminSessionFromSecureConnection(Registry __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            AdminSessionPrx __ret = __obj.createAdminSessionFromSecureConnection(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            AdminSessionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(PermissionDeniedException ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getSessionTimeout(Registry __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        int __ret = __obj.getSessionTimeout(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeInt(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
        "createAdminSession",
        "createAdminSessionFromSecureConnection",
        "createSession",
        "createSessionFromSecureConnection",
        "getSessionTimeout",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___createAdminSession(this, in, __current);
            }
            case 1:
            {
                return ___createAdminSessionFromSecureConnection(this, in, __current);
            }
            case 2:
            {
                return ___createSession(this, in, __current);
            }
            case 3:
            {
                return ___createSessionFromSecureConnection(this, in, __current);
            }
            case 4:
            {
                return ___getSessionTimeout(this, in, __current);
            }
            case 5:
            {
                return ___ice_id(this, in, __current);
            }
            case 6:
            {
                return ___ice_ids(this, in, __current);
            }
            case 7:
            {
                return ___ice_isA(this, in, __current);
            }
            case 8:
            {
                return ___ice_ping(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
